unit WP16u1;

//TO DO: MAKE IT OPEN IN BETTER INITIAL DIRECTORY. Is "CurrentDirectory" an
//   option?Good option?

//NEEDS CODE to provide for user who clicks on "MassageAndOverWrite" before
//   opening a file (and establishing WHERE to write...)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

const vers='23 Sep 13+small tidies but bad initial directory';
  //Started 23 Sep 13, to process draft of tut for DE48

type

  { TWP16f1 }

  TWP16f1 = class(TForm)
    buQuit: TButton;
    buMassageOnly: TButton;
    buOpen: TButton;
    buMassageAndOverwrite: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    procedure buMassageAndOverwriteClick(Sender: TObject);
    procedure buMassageOnlyClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure buOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    //Be careful with any "Tmp" variables, e.g. sTmp
    //    do not assume what will be in them unless you
    //    set was was in them recently. Do not assume that
    //    value will persist... "Tmp" variables are used
    //    subroutines.
    sTmp,sTmpMsg,sFileToProcess:string;
    bTmp:byte;
    procedure Massage;
    procedure Overwrite;

  public
    { public declarations }
  end;

var
  WP16f1: TWP16f1;

implementation

{$R *.lfm}

{ TWP16f1 }

procedure TWP16f1.FormCreate(Sender: TObject);
begin
  //Set up properties of OpenDialog1
  WP16f1.caption:='WP16, version '+vers;//In bar at top of window
  application.title:='WP16';//ID on taskbar
  with OpenDialog1 do begin
     Filter:='Text files|*.txt|All files|*.*';
     //The next is NOT ideal for WP16... but
     //  note for times it IS useful, before revising
     //  for WP16
     InitialDir:=ExtractFilePath(Application.ExeName);
     end;//with

     Memo1.lines.clear;
     Memo1.lines.add('WP16 from http://Sheepdog Software.co.uk');
     Memo1.lines.add('');
     Memo1.lines.add('A simple utility for people writing HTML in a text editor,');
     Memo1.lines.add('and using <pre></pre> blocks to, say, give listings of program sourcecode.');
     Memo1.lines.add('');
     Memo1.lines.add('');
     Memo1.lines.add('WP16 massages files, replacing &, >, < and £ character''s inside');
     Memo1.lines.add('any <pre></pre> blocks with &amp;, &gt;, &lt; &pound;');
     Memo1.lines.add('Be careful: If you massage twice, "&gt;", say, becomes "&amp;gt;"');
     Memo1.lines.add('');
     Memo1.lines.add('Application will not recogize <pre> or </pre> tag if split across');
     Memo1.lines.add('two lines, but other than that, the <pre</pre> tags may');
     Memo1.lines.add('occur anywhere.');
     Memo1.lines.add('Valid syntax (one and only one <pre> before each and every');
     Memo1.lines.add('</pre>, and no extra </pre>s) is required.');
     Memo1.lines.add('');
     Memo1.lines.add('');
     Memo1.lines.add('');

    { Memo1.lines.add('Testing & < >...');
     Memo1.lines.add('<pre>');
     Memo1.lines.add('WE & You do < but not >');
     Memo1.lines.add('</pre>');
     Memo1.lines.add('WE & You do < but not >');
     Memo1.lines.add('xx <pre>WE & You do < > </pre> 123');
     }
  end;

end;

procedure TWP16f1.buMassageOnlyClick(Sender: TObject);
begin
  Massage;
end;

procedure TWP16f1.buMassageAndOverwriteClick(Sender: TObject);
begin
  Massage;
  OverWrite;
end;

procedure TWP16f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure TWP16f1.buOpenClick(Sender: TObject);
begin
  if OpenDialog1.execute then begin
       sFileToProcess:=OpenDialog1.filename;
       Memo1.Lines.loadfromfile(sFileToProcess);
       end;
end;

procedure TWP16f1.Massage;
//BEWARE: &'s are tricky.... don't change "&gt;" to "&amp;gt;" !
var iCurrLine:integer;
    boInPreBlock:boolean;

  procedure MassageLine;// SR of Massage
  //Relies on external "iCurrLine", should not change it.
  //Relies on external "boInPreBlock", MAY change it, and it
  //    should have been set to false before first call of
  //    MassageLine
  var iPosnInLine:integer;
      boDoNoMoreFixesInThisLoopCycle:boolean;

    procedure SeeIfPreBlockStarts;//SR of MassageLine, itself SR of Massage
    //This is called when (boInPreBlock is false AND a "<" is seen),
    //  and checks to see if the "<"
    //  is the start of a "<pre>". If so, we leave this SR with
    //  iPosnInLine pointing to ">" of the <pre>, and
    //  boInPreBlock set to true.
    begin
      if copy(sTmp,iPosnInLine,5)='<pre>' then begin
              //(Quick test done... seems happy enough even if there
              //   are not 5 chars avail in what's left of sTmp
        boInPreBlock:=true;
        iPosnInLine:=iPosnInLine+4;
        boDoNoMoreFixesInThisLoopCycle:=true;
      end;
    end;//SeeIfPreBlockStarts

    procedure SeeIfPreBlockEnds;//SR of MassageLine, itself SR of Massage
    //This is called when (boInPreBlock is true AND a "<" is seen),
    //  and checks to see if the "<"
    //  is the start of a "</pre>". If so, we leave this SR with
    //  iPosnInLine pointing to ">" of the </pre>, and
    //  boInPreBlock set to false.
    begin
      if copy(sTmp,iPosnInLine,6)='</pre>' then begin
              //(Quick test done... seems happy enough even if there
              //   are not 6 chars avail in what's left of sTmp
        boInPreBlock:=false;
        iPosnInLine:=iPosnInLine+5;
        boDoNoMoreFixesInThisLoopCycle:=true;
      end;
    end;//SeeIfPreBlockEnds

    procedure Substitute(sNew:string);//SR of MassageLine, itself SR of Massage
    begin
      //first case of iPosnInLine=1...
      if iPosnInLine=1 then begin
        //showmessage('in sub');
        sTmp:=sNew+copy(sTmp,2,length(sTmp));
        iPosnInLine:=length(sNew);//No "-1"/"+1". Considered.
        end//no ; here. of it iPosnInLine=1
      else
        sTmp:=copy(sTmp,1,iPosnInLine-1)+sNew+copy(sTmp,iPosnInLine+1,length(sTmp)-iPosnInLine);
        iPosnInLine:=iPosnInLine+length(sNew)-1;// "-1" QUITE carefully considered...

    end;

    procedure FixAmp;//SR of MassageLine, itself SR of Massage
    //CARE: Don't "fix" ampersands twice, or you will change, say,
    //"&gt;" to "&amp;gt;"
    begin
      sTmpMsg:='Change "&" in'+chr(13)+sTmp+chr(13)+'?';
      bTmp:=MessageDlg(sTmpMsg,mtConfirmation,[mbYes,mbNO], 0);
      if bTmp=mrYes then Substitute('&amp;');
    end;//FixAmp

  begin //MassageLine
     sTmp:=memo1.Lines[iCurrLine];
     //showmessage(sTmp);

     iPosnInLine:=0;//One BEFORE start of line, because of "pre-inc" in loop
     repeat
       boDoNoMoreFixesInThisLoopCycle:=false;
       inc(iPosnInLine);

       if sTmp<>'' then begin
                                         //showmessage(sTmp[iPosnInLine]);
         if (sTmp[iPosnInLine]='<') and
              (not boInPreBlock)
                then SeeIfPreBlockStarts;
         //Note: iPosnInLine and boDoNoMoreFixesInThisLoopCycle
         //            may change during SeeIfPreBlockStarts

         if (sTmp[iPosnInLine]='<') and
              (boInPreBlock)
                 then SeeIfPreBlockEnds;
         //Note: iPosnInLine and boDoNoMoreFixesInThisLoopCycle
         //            may change during SeeIfPreBlockEnds



         if (boDoNoMoreFixesInThisLoopCycle=false) and
             boInPreBlock then begin
            //boDoNoMoreFixesInThisLoopCycle will be false if
            //   we have just seen a <pre> or a </pre> and so we
            //   will have just entered or left a <pre> block...
            //   At these times, we are looking at a >, but NOT
            //   one that should be changed.

            //Keep list of Fixes done in opening screen consistent with
            //   what program does.

            //ADD FIX "degree"?

               //DO THE FIX FOR ampersands BEFORE others, so that
               //   the ampersands the others introduce don't
               //   ALSO get changed.
               //For ampersand, use FixAmp rather that  Substitute('&amp;').
               //   for the "are you sure?" it supplies
              if (sTmp[iPosnInLine]='&') then FixAmp;

              if (sTmp[iPosnInLine]='>') then Substitute('&gt;');
              if (sTmp[iPosnInLine]='<') then Substitute('&lt;');
              if (sTmp[iPosnInLine]='£') then Substitute('&pound;');

              end;//if boDoNoMoreFixesInThisLoopCycle=false...
       end;//.. of "if sTmp<>''...
     until iPosnInLine>=length(sTmp);//(When sTmp='' is a special case, and
                 //iPosnInLine will be 1 while length(sTmp) is 0... but by
                 //using ">=" we accomodate that.)

     memo1.Lines[iCurrLine]:=sTmp;//Write revised line back to memo
  end;//MassageLine

begin
  iCurrLine:=0;
  boInPreBlock:=false;
  repeat
    MassageLine;//Proc uses value in iCurrLine
    inc(iCurrLine);
  until iCurrLine=Memo1.lines.count;
end;

procedure TWP16f1.OverWrite;
//Should probably add "SaveAs" button
begin
  Memo1.Lines.savetofile(sFileToProcess);
end;



end.

